Bug 540210 - SELinux is preventing firefox-bin from loading /usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so which requires text relocation.
Summary: SELinux is preventing firefox-bin from loading /usr/lib/firefox-2.0.20/extens...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: selinux-policy
Version: 12
Hardware: x86_64
OS: Linux
low
medium
Target Milestone: ---
Assignee: Daniel Walsh
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: setroubleshoot_trace_hash:01f4bc52184...
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-11-22 19:03 UTC by Pär Aronsson
Modified: 2009-12-02 04:41 UTC (History)
2 users (show)

Fixed In Version: 3.6.32-49.fc12
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-12-01 16:41:05 UTC


Attachments (Terms of Use)

Description Pär Aronsson 2009-11-22 19:03:41 UTC
Summary:

SELinux is preventing firefox-bin from loading
/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so
which requires text relocation.

Detailed Description:

The firefox-bin application attempted to load
/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so
which requires text relocation. This is a potential security problem. Most
libraries do not need this permission. Libraries are sometimes coded incorrectly
and request this permission. The SELinux Memory Protection Tests
(http://people.redhat.com/drepper/selinux-mem.html) web page explains how to
remove this requirement. You can configure SELinux temporarily to allow
/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so
to use relocation as a workaround, until the library is fixed. Please file a bug
report (http://bugzilla.redhat.com/bugzilla/enter_bug.cgi) against this package.

Allowing Access:

If you trust
/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so
to run correctly, you can change the file context to textrel_shlib_t. "chcon -t
textrel_shlib_t
'/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so'"
You must also change the default file context files on the system in order to
preserve them even on a full relabel. "semanage fcontext -a -t textrel_shlib_t
'/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so'"

Fix Command:

chcon -t textrel_shlib_t
'/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so'

Additional Information:

Source Context                unconfined_u:unconfined_r:unconfined_execmem_t:s0-
                              s0:c0.c1023
Target Context                system_u:object_r:lib_t:s0
Target Objects                /usr/lib/firefox-2.0.20/extensions/talkback@mozill
                              a.org/components/libqfaservices.so [ file ]
Source                        firefox-bin
Source Path                   /usr/lib/firefox-2.0.20/firefox-bin
Port                          <Unknown>
Host                          (removed)
Source RPM Packages           
Target RPM Packages           
Policy RPM                    selinux-policy-3.6.12-39.fc11
Selinux Enabled               True
Policy Type                   targeted
Enforcing Mode                Enforcing
Plugin Name                   allow_execmod
Host Name                     (removed)
Platform                      Linux (removed) 2.6.29.4-167.fc11.x86_64
                              #1 SMP Wed May 27 17:27:08 EDT 2009 x86_64 x86_64
Alert Count                   1
First Seen                    Mon 15 Jun 2009 08:24:25 PM CEST
Last Seen                     Mon 15 Jun 2009 08:24:25 PM CEST
Local ID                      a209bae7-0a14-4706-872f-dffa04fc0ea5
Line Numbers                  

Raw Audit Messages            

node=(removed) type=AVC msg=audit(1245090265.136:26978): avc:  denied  { execmod } for  pid=31404 comm="firefox-bin" path="/usr/lib/firefox-2.0.20/extensions/talkback@mozilla.org/components/libqfaservices.so" dev=sda6 ino=238395 scontext=unconfined_u:unconfined_r:unconfined_execmem_t:s0-s0:c0.c1023 tcontext=system_u:object_r:lib_t:s0 tclass=file

node=(removed) type=SYSCALL msg=audit(1245090265.136:26978): arch=40000003 syscall=125 success=no exit=-13 a0=838000 a1=4000 a2=5 a3=ffd0f8c0 items=0 ppid=31399 pid=31404 auid=500 uid=500 gid=500 euid=500 suid=500 fsuid=500 egid=500 sgid=500 fsgid=500 tty=pts2 ses=1 comm="firefox-bin" exe="/usr/lib/firefox-2.0.20/firefox-bin" subj=unconfined_u:unconfined_r:unconfined_execmem_t:s0-s0:c0.c1023 key=(null)



Hash String generated from  selinux-policy-3.6.12-39.fc11,allow_execmod,firefox-bin,unconfined_execmem_t,lib_t,file,execmod
audit2allow suggests:

#============= unconfined_execmem_t ==============
allow unconfined_execmem_t lib_t:file execmod;

Comment 1 Daniel Walsh 2009-11-23 16:01:11 UTC
Use the chcon mentioned in the alert.
I will change the default labeling in next release.

Report this as a bug to the plugin provider, as they built their library incorrectly.

http://people.redhat.com/~drepper/selinux-mem.html

Fixed in selinux-policy-3.6.32-48.fc12.noarch

Comment 2 Fedora Update System 2009-11-23 23:40:11 UTC
selinux-policy-3.6.32-49.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/selinux-policy-3.6.32-49.fc12

Comment 3 Fedora Update System 2009-11-25 15:23:30 UTC
selinux-policy-3.6.32-49.fc12 has been pushed to the Fedora 12 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update selinux-policy'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F12/FEDORA-2009-12131

Comment 4 Fedora Update System 2009-12-02 04:34:37 UTC
selinux-policy-3.6.32-49.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.